﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////


var machine = System.Machine;
var MemoryDevices;
var MaxCapacity;
var TotalVirtualMemorySize;
var FreeVirtualMemory;
var FreeSpaceInPagingFiles;

var oRAM;
var firstrun = 1;

var DevName = new Array();
DevName[0] = "BankLabel";
DevName[1] = "DeviceLocator";
DevName[2] = "Capacity";
DevName[3] = "DataWidth";
DevName[3] = "Speed";
DevName[4] = "FormFactor";
DevName[5] = "Manufacturer";
DevName[6] = "PartNumber";
DevName[7] = "MemoryType";
DevName[8] = "TypeDetail";
DevName[9] = "PositionInRow";

var TBody1 = new Array();
var TBody2 = new Array();


function Init()
{
	ramCollect.innerText = SomeText[1];
	ramCollect.style.display="block";

	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");
	headimg.src = "/img/Flyout/ramhead.png";
    setInterval(onTimer,980);
}

function onTimer()
{
	if (firstrun == "1")
	{
	    firstrun = "0";
	}
	else
	{
		GetRAMInfo();
	    firstrun = "0";
	}
}

function GetRAMInfo()
{
	if (firstrun == 0)
	{
		clearTable("rTable");
		clearTable("rTabelle");
	}

	oRAM = GetObject("winmgmts:\\\\.\\root\\CIMV2");
//	oRAM = GetObject("winmgmts:\\\\.\\root\\WMI");

	var proc;
	var query;
	var enu
	query="SELECT * FROM Win32_PhysicalMemoryArray";
	proc = oRAM.ExecQuery(query,"WQL",48);
	enu = new Enumerator(proc);
	MemoryDevices = enu.item().MemoryDevices;
	MaxCapacity = enu.item().MaxCapacity / 1024;

	query="SELECT * FROM Win32_OperatingSystem";
	proc = oRAM.ExecQuery(query,"WQL",48);
	enu = new Enumerator(proc);
	TotalVirtualMemorySize = parseInt(enu.item().TotalVirtualMemorySize / 1024);
	FreeVirtualMemory = parseInt(enu.item().FreeVirtualMemory / 1024);
	FreeSpaceInPagingFiles = parseInt(enu.item().FreeSpaceInPagingFiles / 1024);

//	var query="SELECT * FROM CIM_PhysicalMemory WHERE Tag=";
	query="SELECT * FROM Win32_PhysicalMemory WHERE Tag=";
	query += "\"Physical Memory 0\"";
	proc = oRAM.ExecQuery(query,"WQL",48);
	ShowDevices(proc, "TBody1");

	if (MemoryDevices != 1)
	{
//		query="SELECT * FROM CIM_PhysicalMemory WHERE Tag=";
		query="SELECT * FROM Win32_PhysicalMemory WHERE Tag=";
		query += "\"Physical Memory 1\"";
		proc = oRAM.ExecQuery(query,"WQL",48);
		ShowDevices(proc, "TBody2");

		var systotmem = ((TBody1[2] / 1024) / 1024) + ((TBody2[2] / 1024) / 1024);
	}
	else
	{
		var systotmem = ((TBody1[2] / 1024) / 1024);
	}

	var totmem = machine.totalMemory;
	var avlmem = machine.availableMemory;
	var usemem = totmem - avlmem;
	AddRAMUsage("rTable", "MemoryDevices", MemoryDevices);
	AddRAMUsage("rTable", "MaxCapacity", MaxCapacity+"MB");
	AddRAMUsage("rTable", "SystemTotalMemory", systotmem+"MB");
	AddRAMUsage("rTable", "WindowsTotalMemory", totmem+"MB");
	AddRAMUsage("rTable", "UsedMemory", usemem+"MB");
	AddRAMUsage("rTable", "AvailableMemory", avlmem+"MB");
	AddRAMUsage("rTable", "TotalVirtualMemorySize", TotalVirtualMemorySize+"MB");
	AddRAMUsage("rTable", "FreeVirtualMemory", FreeVirtualMemory+"MB");
	AddRAMUsage("rTable", "FreeSpaceInPagingFiles", FreeSpaceInPagingFiles+"MB");

	newTableRow(DevName.length);

	rfoot.innerText = SomeText[0];
	ramCollect.style.display="none";
}

function ShowDevices(instances, className)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			for (var i=0; i<DevName.length; i++)
			{
				if (prop.Name == DevName[i])
				{
					var pval="";
					if (prop.Value)
					{
						if (prop.Value.length > 2)
						{
							var swtest = prop.Value.substr(0,2);
							if (swtest == "0x")
							{
								pval = HEXtoString(prop.Value);
							}
							else
							{
								pval = prop.Value;
							}
						}
						else
						{
							pval = prop.Value;
						}
					}
					else
					{
						pval = "--";
					}

					if (pval.length>18) pval=pval.substr(0,18)+"...";

					if (className == "TBody1")
					{
						TBody1[i] = pval;
					}
					else
					{
						TBody2[i] = pval;
					}
				}
			}
		}
	}
}

function HEXtoString(wert)
{
	var realword = "";
	var subword = "";
	var sw = wert.substr(2);
	var swlenght = sw.length;

	for (var i=0; i < swlenght; i=i+2)
	{
		subword = sw.substring(i, i+2);
		realword = realword + "%" + String(subword);
	}

	return unescape(realword);
}

function newTableRow(DNlen)
{
	for (var i=0; i < DNlen; i++)
	{
		if (DevName[i] == "Capacity")
		{
			var cap1= ((TBody1[i] / 1024) / 1024) + "MB";
			var cap2= ((TBody2[i] / 1024) / 1024) + "MB";
			AddRow("rTabelle", DevName[i], cap1, cap2);
		}
		else if (DevName[i] == "FormFactor")
		{
			AddRow("rTabelle", DevName[i], FormFactor[TBody1[i]], FormFactor[TBody2[i]]);
		}
		else if (DevName[i] == "MemoryType")
		{
			AddRow("rTabelle", DevName[i], MemType[TBody1[i]], MemType[TBody2[i]]);
		}
		else if (DevName[i] == "TypeDetail")
		{
			AddRow("rTabelle", DevName[i], TypeDetail[TBody1[i]], TypeDetail[TBody2[i]]);
		}
		else
		{
			AddRow("rTabelle", DevName[i], TBody1[i], TBody2[i]);
		}
	}
}

function AddRow(tab, content, content2, content3)
{
	var TabElem = document.getElementById(tab);
	var NewRow = document.createElement("tr");
	if(NewRow.style.display)
	{
		NewRow.style.display="table-row";
	}

	var NewRowContent = document.createElement("td");
	if(NewRowContent.style.display)
	{
		NewRowContent.style.display="table-cell";
		NewRowContent.style.width=70;
		NewRowContent.style.whiteSpace="normal";
	}
	var NewRowContent_Text = document.createTextNode(content);
	NewRowContent.appendChild(NewRowContent_Text);

	var NewRowContent2 = document.createElement("td");
	if(NewRowContent2.style.display)
	{
		NewRowContent2.style.display="table-cell";
		NewRowContent2.style.width=150;
		NewRowContent2.style.whiteSpace="normal";
	}
	var NewRowContent2_Text = document.createTextNode(content2);
	NewRowContent2.appendChild(NewRowContent2_Text);

	NewRow.appendChild(NewRowContent);
	NewRow.appendChild(NewRowContent2);

	if (MemoryDevices != 1)
	{
		var NewRowContent3 = document.createElement("td");
		if(NewRowContent3.style.display)
		{
			NewRowContent3.style.display="table-cell";
			NewRowContent3.style.width=150;
			NewRowContent3.style.whiteSpace="normal";
		}
		var NewRowContent3_Text = document.createTextNode(content3);
		NewRowContent3.appendChild(NewRowContent3_Text);
		NewRow.appendChild(NewRowContent3);
	}

	TabElem.getElementsByTagName("tbody")[0].appendChild(NewRow);

//	if(document.getElementById(tab).outerHTML)document.getElementById(tab).outerHTML=document.getElementById(tab).outerHTML;
}

function AddRAMUsage(tab, content, content2)
{
	var TabElem = document.getElementById(tab);
	var NewRow = document.createElement("tr");
	if(NewRow.style.display)
	{
		NewRow.style.display="table-row";
	}

	var NewRowContent = document.createElement("td");
	if(NewRowContent.style.display)
	{
		NewRowContent.style.display="table-cell";
		NewRowContent.style.width=70;
		NewRowContent.style.whiteSpace="normal";
	}
	var NewRowContent_Text = document.createTextNode(content);
	NewRowContent.appendChild(NewRowContent_Text);

	var NewRowContent2 = document.createElement("td");
	if(NewRowContent2.style.display)
	{
		NewRowContent2.style.display="table-cell";
		NewRowContent2.style.width=110;
		NewRowContent2.style.align="right";
		NewRowContent2.style.whiteSpace="normal";
	}
	var NewRowContent2_Text = document.createTextNode(content2);
	NewRowContent2.appendChild(NewRowContent2_Text);

	NewRow.appendChild(NewRowContent);
	NewRow.appendChild(NewRowContent2);
	TabElem.getElementsByTagName("tbody")[0].appendChild(NewRow);

//	if(document.getElementById(tab).outerHTML)document.getElementById(tab).outerHTML=document.getElementById(tab).outerHTML;
}

function clearTable(wert)
{
	if (wert == "rTable")
	{
		var rowsnum = rTable.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			rTable.deleteRow(i);
		}
	}
	else if (wert == "rTabelle")
	{
		var rowsnum = rTabelle.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			rTabelle.deleteRow(i);
		}
	}
}


